(function () {
    'use strict';

    angular
        .module('app.core')
        .config(config);

    /** @ngInject */
    function config($logProvider, $translateProvider, localStorageServiceProvider) {
        // Enable debug logging
        $logProvider.debugEnabled(true);

        // angular-translate configuration
        $translateProvider.useLoader('$translatePartialLoader', {
            urlTemplate: '{part}/i18n/{lang}.json'
        });
        $translateProvider.preferredLanguage('en');
        $translateProvider.useSanitizeValueStrategy('sanitize');

        // Prefix for local storage
        localStorageServiceProvider.setPrefix('sta');
        localStorageServiceProvider.setNotify(true, true);
    }
})();
