(function () {
    'use strict';

    angular
        .module('app.core')
        .factory('KeyEventHandler', KeyEventHandler);

    /** @ngInject */
    function KeyEventHandler() {
        // Return the constructor function.
        return ( KeyEventHandler );


        // I provide event-binding methods that are pre-bound to the given
        // priority and terminal settings.
        function KeyEventHandler(keyEvents, priority, isTerminal) {

            // I hold the collection of event handlers associated.
            var eventHandlers = {
                keydown: [],
                keypress: [],
                keyup: []
            };

            // Setup the public API.
            var api = {
                keydown: keydown,
                keypress: keypress,
                keyup: keyup,
                teardown: teardown,
                teardownType: teardownEventType
            };

            // Return the public API.
            return ( api );


            // PUBLIC METHODS.

            // I bind the given handler to the keydown event.
            function keydown(handler) {

                eventHandlers.keydown.push(handler);

                keyEvents.on('keydown', handler, priority, isTerminal);

                return ( api );

            }


            // I bind the given handler to the keypress event.
            function keypress(handler) {

                eventHandlers.keypress.push(handler);

                keyEvents.on('keypress', handler, priority, isTerminal);

                return ( api );

            }


            // I bind the given handler to the keyup event.
            function keyup(handler) {

                eventHandlers.keyup.push(handler);

                keyEvents.on('keyup', handler, priority, isTerminal);

                return ( api );

            }


            // I unbind all of the event handlers bound by this proxy.
            function teardown() {

                teardownEventType('keydown');
                teardownEventType('keypress');
                teardownEventType('keyup');

            }


            // PRIVATE METHODS.


            // I unbind the specific handlers from the core keyEvents service.
            function teardownEventType(eventType) {

                var handlers = eventHandlers[eventType];

                for (var i = 0, length = handlers.length; i < length; i++) {

                    keyEvents.off(eventType, handlers[i]);

                }

            }

        }
    }

})();
