(function () {
    'use strict';

    angular
        .module('app.core')
        .directive('ngKeyEvent', keyEventDirective);

    /** @ngInject */
    function keyEventDirective(keyEvents, STA, $state, $rootScope, $window) {
        return {
            restrict: 'A',
            link: function link(scope, element, attrs) {
                // Create a new key-handler with priority (1) - this is the lowest
                // priority in the application. This means that we will get access
                // to key events that haven't been terminally blocked by other
                // directives in the application.
                keyEvents.handler(1).keydown(function handleKeyEvent(event) {
                    if ($rootScope.disableKeys) {
                        switch (event.keyCode) {
                            case STA.keys.VK_BACK:
                                return false;
                                break;
                        }
                    } else {
                        switch (event.keyCode) {
                            case STA.keys.VK_BACK:
                                if ($state.$current.previous) {
                                    var state = $state.$current.previous;
                                    $state.go(state.name, state.params);
                                    return false;
                                } else if ($state.$current.name === 'app.main') {
                                    STA.close();
                                    return false;
                                } else {
                                    $window.history.back();
                                }
                                break;
                        }
                    }
                });
            }
        }
    }
})();
