(function () {
    'use strict';

    angular
        .module('app.core')
        .directive('scroll', scrollDirective);

    /** @ngInject */
    function scrollDirective(keyEvents, STA, $interval) {
        return {
            restrict: 'EA',
            replace: true,
            transclude: true,
            templateUrl: 'app/core/directives/scroll/scroll.html',
            link: function (scope, element, attrs) {
                scope.getUp = getUp;
                scope.getDown = getDown;

                var scrollTop = 0;
                var step = 30;

                function getUp(event) {
                    if (scrollTop !== 0) {
                        scrollTop = scrollTop + step;

                        if (scrollTop >= 0) {
                            scrollTop = 0;
                        }

                        translate(scrollTop);
                    }
                }

                function getDown(event) {
                    var max = getMaxScroll() * -1;

                    if (max !== 0) {
                        scrollTop = scrollTop - step;

                        if (scrollTop <= max) {
                            scrollTop = max;
                        }

                        translate(scrollTop);
                    }
                }

                function getMaxScroll() {
                    var wrapper = $(element).outerHeight();
                    var content = $(element).find('.scroll-content').outerHeight();

                    if (content <= wrapper) {
                        return 0;
                    } else {
                        return content - wrapper;
                    }
                }

                function translate(value) {
                    $(element).find('.scroll-scroller')
                        .css('-webkit-transform', 'translate(0px, ' + value + 'px)')
                        .css('-moz-transform', 'translate(0px, ' + value + 'px)')
                        .css('-ms-transform', 'translate(0px, ' + value + 'px)')
                        .css('-o-transform', 'translate(0px, ' + value + 'px)')
                        .css('transform', 'translate(0px, ' + value + 'px)')
                }

                var checkArrows = $interval(function () {
                    if ($(element).outerHeight() >= $(element).find('.scroll-content').outerHeight()) {
                        scope.hideScroll = true;
                    } else {
                        scope.hideScroll = false;
                    }
                }, 100);

                scope.$on('$destroy', function () {
                    $interval.cancel(checkArrows);
                });
            }
        };
    }

})();
