(function () {
    'use strict';

    angular
        .module('app.core')
        .filter('truncate', filterTruncate);

    /** @ngInject */
    function filterTruncate() {
        return function (text, length, end) {
            if (isNaN(length)) {
                length = 10;
            }

            if (!end) {
                end = '...';
            }

            if (!text || (text.length <= length || text.length - end.length <= length)) {
                return text;
            } else {
                return String(text).substring(0, length - end.length) + end;
            }

        };
    }
})();
