(function () {
    'use strict';

    angular
        .module('app.core')
        .service('OmdbService', OmdbService);

    /** @ngInject */
    function OmdbService($http, $window) {
        return {
            get: function (id) {
                return $http({
                    url: 'http://www.omdbapi.com?i=' + id + '&plot=full&r=json',
                    method: 'GET'
                });
            },
            search: function (title) {
                return $http({
                    url: 'http://www.omdbapi.com?s=' + $window.encodeURIComponent(title) + '&type=movie&r=json',
                    method: 'GET'
                });
            }
        };
    }
})();
