(function () {
    'use strict';

    angular
        .module('app.core')
        .service('STAPIService', STAPIService);

    /** @ngInject */
    function STAPIService($http, $q) {
        var currentList;

        return {
            get: function (id, callback) {
                var cb = callback || angular.noop;
                var deferred = $q.defer();
                var result;

                if (currentList) {
                    result = (id) ? getMovie(currentList, id) : currentList;
                    cb(null, result);
                    deferred.resolve(result);
                    return deferred.promise;
                }

                $http({
                    url: 'http://erdn.info/distribute/list.json',
                    method: 'GET'
                }).then(function (data) {
                    currentList = data.data;
                    result = (id) ? getMovie(currentList, id) : currentList;
                    cb(null, result);
                    return deferred.resolve(result);
                }, function (err) {
                    currentList = null;
                    cb(err);
                    return deferred.reject(err);
                });

                return deferred.promise;
            }
        };

        function getMovie(list, id) {
            return _.find(list, function (item) {
                return item && item.id == id;
            });
        }
    }
})();
