(function () {
    'use strict';

    angular
        .module('app.core')
        .factory('UI', UIFactory);

    /** @ngInject */
    function UIFactory($rootScope, $timeout, $window) {
        // Private variables

        var service = {
            focus: focus,
            loading: function (value) {
                return $rootScope.$broadcast('$showLoading', value);
            },
            hideSplash: hideSplash
        };

        return service;

        //////////

        /**
         * Focus on the class name
         */
        function focus(className, isId) {
            var element;
            if (isId) {
                element = $window.document.getElementById(className);
            } else {
                element = $window.document.getElementsByClassName(className)[0];
            }

            if (element)
                $(element).focus();
        }

        function hideSplash() {
            $rootScope.splashScreen = true;
        }
    }
}());
