(function () {
    'use strict';

    angular
        .module('app.page.list')
        .controller('InputController', InputController);

    /** @ngInject */
    function InputController(STA, $scope, $rootScope) {
        var vm = this;

        function searchValue(obj, val) {
            for (var prop in obj) {
                if (obj.hasOwnProperty(prop)) {
                    if (obj[prop] === val) {
                        return prop;
                    }
                }
            }

            return null;
        }

        function handleKey(evt) {
            evt.preventDefault();
            evt.stopPropagation();

            var key = vm.currentKey = searchValue(STA.keys, evt.keyCode);

            if (evt.keyCode == STA.keys.VK_BACK) {
                document.removeEventListener('keydown', handleKey, true);
                document.getElementById('appinput').focus();

                $rootScope.disableKeys = false;

                vm.PRESSKEY = 'INPUT.PRESSKEY';
            } else {
                vm.PRESSKEY = 'INPUT.PRESSBACK';
            }

            $scope.$apply();
        }

        vm.PRESSKEY = 'INPUT.PRESSKEY';
        vm.currentKey = null;
        vm.capabilities = STA.getCapabilities();
        vm.handleKeys = function (evt) {
            $rootScope.disableKeys = true;
            document.addEventListener('keydown', handleKey, true);
        }

        $scope.$on('$destroy', function () {
            $rootScope.disableKeys = false;
        });
    }
})();
