(function () {
    'use strict';

    angular
        .module('app.page.main')
        .controller('MainController', MainController);

    /** @ngInject */
    function MainController(STA) {
        var vm = this;

        vm.widgets = [{
            title: 'MAIN.SETTINGS',
            default: 'Settings',
            items: normalizedOptions(STA.settings)
        }, {
            title: 'MAIN.PLATFORM',
            default: 'Platform',
            items: normalizedOptions(STA.platform)
        }, {
            title: (_.isEmpty(STA.capabilities) ? 'MAIN.NOCAPABILITIES' : 'MAIN.CAPABILITIES'),
            default: 'Capabilities',
            items: normalizedOptions(STA.capabilities)
        }];

        //////

        function normalizedOptions(options) {
            var result = [];

            _.forEach(options, function (i, k) {
                result.push({
                    title: k,
                    value: i
                });
            });

            return result;
        }
    }
})();
