(function () {
    'use strict';

    angular
        .module('app.page.search')
        .controller('SearchController', SearchController);

    /** @ngInject */
    function SearchController($scope, STAPIService, UI, $filter, config) {
        var vm = this;
        var watchSearch;
        var search = $filter('search');
        config('backDetails', 'app.search');
        vm.searchTitle = '';

        UI.loading(true);

        STAPIService.get()
            .then(function (data) {
                UI.loading(false);
                vm.showloader = false;
                vm.results = data;

                watchSearch = $scope.$watch('vm.searchTitle', function (value) {
                    if (value) {
                        vm.results = search(vm.results, value);
                    } else {
                        vm.results = data;
                    }
                }, true);
            });

        $scope.$on('$destroy', function () {
            watchSearch();
        });
    }
})();
